<?php
/* Autor...:  */
/* Esquema.: GSS_Sucursal.xml */
/* Generado: 2022-01-18 15:31:54 */

/* Metodos de acceso a los campos de la tabla GSS_Sucursal */
abstract class BaseGSS_SucursalBN
{
    /* Campos de la tabla */
    private $i_IdSucursal;    // IdSucursal: ( no definido )
    private $i_IdCompania;    // IdCompania: ( no definido )
    private $i_IdUnidadProduccion;    // IdUnidadProduccion: ( no definido )
    private $s_IdAlmacen;    // IdAlmacen: ( no definido )
    private $s_CodigoSunat;    // CodigoSunat: ( no definido )
    private $s_Descripcion;    // Descripcion: ( no definido )
    private $s_Departamento;    // Departamento: ( no definido )
    private $s_Provincia;    // Provincia: ( no definido )
    private $s_Distrito;    // Distrito: ( no definido )
    private $s_Direccion;    // Direccion: ( no definido )
    private $s_Telefono;    // Telefono: ( no definido )
    private $s_Longitud;    // Longitud: ( no definido )
    private $s_Latitud;    // Latitud: ( no definido )
    private $s_Ubigeo;    // Ubigeo: ( no definido )
    private $s_Ip;    // Ip: ( no definido )
    private $s_CuentaContableDefecto;    // CuentaContableDefecto: ( no definido )
    private $i_EstaExoneradoIGV;    // EstaExoneradoIGV: ( no definido )
    private $s_RutaProveedorExt;    // RutaProveedorExt: ( no definido )
    private $s_TokenProveedorExt;    // TokenProveedorExt: ( no definido )
    private $s_Estado;    // Estado: ( no definido )
    private $d_FechaCreacion;    // FechaCreacion: ( no definido )
    private $s_UsuarioCreacion;    // UsuarioCreacion: ( no definido )
    private $d_FechaModificacion;    // FechaModificacion: ( no definido )
    private $s_UsuarioModificacion;    // UsuarioModificacion: ( no definido )

    /* Establece el valor del campo IdSucursal */
    public function setIdSucursal( $i_IdSucursal )
    {
        $this->i_IdSucursal = $i_IdSucursal;
    }

    /* Obtiene el valor del campo IdSucursal */
    public function getIdSucursal()
    {
        return $this->i_IdSucursal;
    }

    /* Establece el valor del campo IdCompania */
    public function setIdCompania( $i_IdCompania )
    {
        $this->i_IdCompania = $i_IdCompania;
    }

    /* Obtiene el valor del campo IdCompania */
    public function getIdCompania()
    {
        return $this->i_IdCompania;
    }

    /* Establece el valor del campo IdUnidadProduccion */
    public function setIdUnidadProduccion( $i_IdUnidadProduccion )
    {
        $this->i_IdUnidadProduccion = $i_IdUnidadProduccion;
    }

    /* Obtiene el valor del campo IdUnidadProduccion */
    public function getIdUnidadProduccion()
    {
        return $this->i_IdUnidadProduccion;
    }

    /* Establece el valor del campo IdAlmacen */
    public function setIdAlmacen( $s_IdAlmacen )
    {
        $this->s_IdAlmacen = $s_IdAlmacen;
    }

    /* Obtiene el valor del campo IdAlmacen */
    public function getIdAlmacen()
    {
        return $this->s_IdAlmacen;
    }

    /* Establece el valor del campo CodigoSunat */
    public function setCodigoSunat( $s_CodigoSunat )
    {
        $this->s_CodigoSunat = $s_CodigoSunat;
    }

    /* Obtiene el valor del campo CodigoSunat */
    public function getCodigoSunat()
    {
        return $this->s_CodigoSunat;
    }

    /* Establece el valor del campo Descripcion */
    public function setDescripcion( $s_Descripcion )
    {
        $this->s_Descripcion = $s_Descripcion;
    }

    /* Obtiene el valor del campo Descripcion */
    public function getDescripcion()
    {
        return $this->s_Descripcion;
    }

    /* Establece el valor del campo Departamento */
    public function setDepartamento( $s_Departamento )
    {
        $this->s_Departamento = $s_Departamento;
    }

    /* Obtiene el valor del campo Departamento */
    public function getDepartamento()
    {
        return $this->s_Departamento;
    }

    /* Establece el valor del campo Provincia */
    public function setProvincia( $s_Provincia )
    {
        $this->s_Provincia = $s_Provincia;
    }

    /* Obtiene el valor del campo Provincia */
    public function getProvincia()
    {
        return $this->s_Provincia;
    }

    /* Establece el valor del campo Distrito */
    public function setDistrito( $s_Distrito )
    {
        $this->s_Distrito = $s_Distrito;
    }

    /* Obtiene el valor del campo Distrito */
    public function getDistrito()
    {
        return $this->s_Distrito;
    }

    /* Establece el valor del campo Direccion */
    public function setDireccion( $s_Direccion )
    {
        $this->s_Direccion = $s_Direccion;
    }

    /* Obtiene el valor del campo Direccion */
    public function getDireccion()
    {
        return $this->s_Direccion;
    }

    /* Establece el valor del campo Telefono */
    public function setTelefono( $s_Telefono )
    {
        $this->s_Telefono = $s_Telefono;
    }

    /* Obtiene el valor del campo Telefono */
    public function getTelefono()
    {
        return $this->s_Telefono;
    }

    /* Establece el valor del campo Longitud */
    public function setLongitud( $s_Longitud )
    {
        $this->s_Longitud = $s_Longitud;
    }

    /* Obtiene el valor del campo Longitud */
    public function getLongitud()
    {
        return $this->s_Longitud;
    }

    /* Establece el valor del campo Latitud */
    public function setLatitud( $s_Latitud )
    {
        $this->s_Latitud = $s_Latitud;
    }

    /* Obtiene el valor del campo Latitud */
    public function getLatitud()
    {
        return $this->s_Latitud;
    }

    /* Establece el valor del campo Ubigeo */
    public function setUbigeo( $s_Ubigeo )
    {
        $this->s_Ubigeo = $s_Ubigeo;
    }

    /* Obtiene el valor del campo Ubigeo */
    public function getUbigeo()
    {
        return $this->s_Ubigeo;
    }

    /* Establece el valor del campo Ip */
    public function setIp( $s_Ip )
    {
        $this->s_Ip = $s_Ip;
    }

    /* Obtiene el valor del campo Ip */
    public function getIp()
    {
        return $this->s_Ip;
    }

    /* Establece el valor del campo CuentaContableDefecto */
    public function setCuentaContableDefecto( $s_CuentaContableDefecto )
    {
        $this->s_CuentaContableDefecto = $s_CuentaContableDefecto;
    }

    /* Obtiene el valor del campo CuentaContableDefecto */
    public function getCuentaContableDefecto()
    {
        return $this->s_CuentaContableDefecto;
    }

    /* Establece el valor del campo EstaExoneradoIGV */
    public function setEstaExoneradoIGV( $i_EstaExoneradoIGV )
    {
        $this->i_EstaExoneradoIGV = $i_EstaExoneradoIGV;
    }

    /* Obtiene el valor del campo EstaExoneradoIGV */
    public function getEstaExoneradoIGV()
    {
        return $this->i_EstaExoneradoIGV;
    }

    /* Establece el valor del campo RutaProveedorExt */
    public function setRutaProveedorExt( $s_RutaProveedorExt )
    {
        $this->s_RutaProveedorExt = $s_RutaProveedorExt;
    }

    /* Obtiene el valor del campo RutaProveedorExt */
    public function getRutaProveedorExt()
    {
        return $this->s_RutaProveedorExt;
    }

    /* Establece el valor del campo TokenProveedorExt */
    public function setTokenProveedorExt( $s_TokenProveedorExt )
    {
        $this->s_TokenProveedorExt = $s_TokenProveedorExt;
    }

    /* Obtiene el valor del campo TokenProveedorExt */
    public function getTokenProveedorExt()
    {
        return $this->s_TokenProveedorExt;
    }

    /* Establece el valor del campo Estado */
    public function setEstado( $s_Estado )
    {
        $this->s_Estado = $s_Estado;
    }

    /* Obtiene el valor del campo Estado */
    public function getEstado()
    {
        return $this->s_Estado;
    }

    /* Establece el valor del campo FechaCreacion */
    public function setFechaCreacion( $d_FechaCreacion )
    {
        $this->d_FechaCreacion = $d_FechaCreacion;
    }

    /* Obtiene el valor del campo FechaCreacion */
    public function getFechaCreacion()
    {
        return $this->d_FechaCreacion;
    }

    /* Establece el valor del campo UsuarioCreacion */
    public function setUsuarioCreacion( $s_UsuarioCreacion )
    {
        $this->s_UsuarioCreacion = $s_UsuarioCreacion;
    }

    /* Obtiene el valor del campo UsuarioCreacion */
    public function getUsuarioCreacion()
    {
        return $this->s_UsuarioCreacion;
    }

    /* Establece el valor del campo FechaModificacion */
    public function setFechaModificacion( $d_FechaModificacion )
    {
        $this->d_FechaModificacion = $d_FechaModificacion;
    }

    /* Obtiene el valor del campo FechaModificacion */
    public function getFechaModificacion()
    {
        return $this->d_FechaModificacion;
    }

    /* Establece el valor del campo UsuarioModificacion */
    public function setUsuarioModificacion( $s_UsuarioModificacion )
    {
        $this->s_UsuarioModificacion = $s_UsuarioModificacion;
    }

    /* Obtiene el valor del campo UsuarioModificacion */
    public function getUsuarioModificacion()
    {
        return $this->s_UsuarioModificacion;
    }

    public function getJsonSerialize()
    {
        return 
        [
            'IdSucursal' => $this->getIdSucursal(),
            'IdCompania' => $this->getIdCompania(),
            'IdUnidadProduccion' => $this->getIdUnidadProduccion(),
            'IdAlmacen' => $this->getIdAlmacen(),
            'CodigoSunat' => $this->getCodigoSunat(),
            'Descripcion' => $this->getDescripcion(),
            'Departamento' => $this->getDepartamento(),
            'Provincia' => $this->getProvincia(),
            'Distrito' => $this->getDistrito(),
            'Direccion' => $this->getDireccion(),
            'Telefono' => $this->getTelefono(),
            'Longitud' => $this->getLongitud(),
            'Latitud' => $this->getLatitud(),
            'Ubigeo' => $this->getUbigeo(),
            'Ip' => $this->getIp(),
            'CuentaContableDefecto' => $this->getCuentaContableDefecto(),
            'EstaExoneradoIGV' => $this->getEstaExoneradoIGV(),
            'RutaProveedorExt' => $this->getRutaProveedorExt(),
            'TokenProveedorExt' => $this->getTokenProveedorExt(),
            'Estado' => $this->getEstado(),
            'FechaCreacion' => $this->getFechaCreacion(),
            'UsuarioCreacion' => $this->getUsuarioCreacion(),
            'FechaModificacion' => $this->getFechaModificacion(),
            'UsuarioModificacion' => $this->getUsuarioModificacion(),
        ];
    }

    public function toArray()
    {
        return $this->processArray( get_object_vars( $this ) ); 
    }

    private function processArray( $array )
    {
        foreach( $array as $key => $value ) 
        {
            if ( is_object( $value ) )
            {
                $array[$key] = $value->toArray();
            }
            if ( is_array( $value ) ) 
            {
                $array[$key] = $this->processArray( $value );
            }
        }
        return $array;
    }

    public function __toString()
    {
        return json_encode( $this->toArray() ); 
    }

    /* Recupera un objeto GSS_SucursalBN desde un RecordSet */
    public static function retrieveByRs( $o_GSS_SucursalRs )
    {
        $o_GSS_SucursalBN = new GSS_SucursalBN();
        $o_GSS_SucursalBN->setIdSucursal( ( integer ) $o_GSS_SucursalRs[ "IdSucursal" ] );
        $o_GSS_SucursalBN->setIdCompania( ( integer ) $o_GSS_SucursalRs[ "IdCompania" ] );
        $o_GSS_SucursalBN->setIdUnidadProduccion( ( integer ) $o_GSS_SucursalRs[ "IdUnidadProduccion" ] );
        $o_GSS_SucursalBN->setIdAlmacen( $o_GSS_SucursalRs[ "IdAlmacen" ] );
        $o_GSS_SucursalBN->setCodigoSunat( $o_GSS_SucursalRs[ "CodigoSunat" ] );
        $o_GSS_SucursalBN->setDescripcion( $o_GSS_SucursalRs[ "Descripcion" ] );
        $o_GSS_SucursalBN->setDepartamento( $o_GSS_SucursalRs[ "Departamento" ] );
        $o_GSS_SucursalBN->setProvincia( $o_GSS_SucursalRs[ "Provincia" ] );
        $o_GSS_SucursalBN->setDistrito( $o_GSS_SucursalRs[ "Distrito" ] );
        $o_GSS_SucursalBN->setDireccion( $o_GSS_SucursalRs[ "Direccion" ] );
        $o_GSS_SucursalBN->setTelefono( $o_GSS_SucursalRs[ "Telefono" ] );
        $o_GSS_SucursalBN->setLongitud( $o_GSS_SucursalRs[ "Longitud" ] );
        $o_GSS_SucursalBN->setLatitud( $o_GSS_SucursalRs[ "Latitud" ] );
        $o_GSS_SucursalBN->setUbigeo( $o_GSS_SucursalRs[ "Ubigeo" ] );
        $o_GSS_SucursalBN->setIp( $o_GSS_SucursalRs[ "Ip" ] );
        $o_GSS_SucursalBN->setCuentaContableDefecto( $o_GSS_SucursalRs[ "CuentaContableDefecto" ] );
        $o_GSS_SucursalBN->setEstaExoneradoIGV( ( integer ) $o_GSS_SucursalRs[ "EstaExoneradoIGV" ] );
        $o_GSS_SucursalBN->setRutaProveedorExt( $o_GSS_SucursalRs[ "RutaProveedorExt" ] );
        $o_GSS_SucursalBN->setTokenProveedorExt( $o_GSS_SucursalRs[ "TokenProveedorExt" ] );
        $o_GSS_SucursalBN->setEstado( $o_GSS_SucursalRs[ "Estado" ] );
        $o_GSS_SucursalBN->setFechaCreacion( utilTimestamp::getTimestamp( $o_GSS_SucursalRs[ "FechaCreacion" ], "Y-m-d H:i:s" ) );
        $o_GSS_SucursalBN->setUsuarioCreacion( $o_GSS_SucursalRs[ "UsuarioCreacion" ] );
        $o_GSS_SucursalBN->setFechaModificacion( utilTimestamp::getTimestamp( $o_GSS_SucursalRs[ "FechaModificacion" ], "Y-m-d H:i:s" ) );
        $o_GSS_SucursalBN->setUsuarioModificacion( $o_GSS_SucursalRs[ "UsuarioModificacion" ] );
        return $o_GSS_SucursalBN;
    }
}
?>